#define FIELDKEYLEN     6
#define FIELDDESCLEN    20
#define FIELDDEF        struct _fielddef
FIELDDEF {
    BYTE key[FIELDKEYLEN];
    char desc[FIELDDESCLEN];
    FIELDDEF *next;
};

#define FIELDINFO         struct _fieldinfo
FIELDINFO {
    FIELDDEF *first;
    int hex;
    int keylen;
    int desclen;
};
extern FIELDINFO fieldinfo[];

extern void      DpuSelectFilt(int srow, int scol, DPFILT **pFilt);
extern void      DpuSelectPreFilt(int srow, int scol, int Dev);
extern void      DpuError(char *format, ...);
extern DPKEY     DpuGetFile(char *header, char *filemask, char *fname, int *OldElem);

extern void      DpuSelectStation(int row, int col, int nrow, char *Station, int *Element);

extern int       DpuDumpInit(char *dumpfile, int mode);
extern unsigned int       
                 DpuDumpCount(long *fpos, unsigned int maxframes, char *TimeStamp);
extern void      DpuDumpSeek(long fpos);
extern void      DpuDumpReadFrame(DPBUF *frp, BYTE *buf);
extern void      DpuDumpWriteFrame(DPBUF *frp);
extern void      DpuDumpEnd(void);

extern int       DpuIniInit(char *infile);
extern int       DpuIniFindId(char *fname);
extern FIELDDEF *DpuIniFindDef(int id, BYTE *key);
extern void      DpuIniEnd(void);

extern void      DpuLogoDNPAP(int row, int col, int size);
extern void      DpuPerc(PWWIN *pWin, int row, int col, int Perc);
extern int       DpuProcSelect(PWWIN *pWin, int Action, int Element);

#ifdef TRACE
void DpuTrace(int Level, char *format, ...);
#endif
